uk.ac.starlink.table.storage

## Class ListRowStore

- java.lang.Object
- - uk.ac.starlink.table.storage.ListRowStore

- All Implemented Interfaces:
    RowStore, TableSink

      public class ListRowStore
      extends java.lang.Object
      implements RowStore

  Implementation of RowStore which stores data in memory. The current implementation uses a `RowListStarTable`. This is better-behaved than the RowStore contract requires; it is guaranteed to be able to store any StarTable object (`acceptMetadata(uk.ac.starlink.table.StarTable)` will not throw a `TableFormatException`). Cautious users of this class will note the fact that for large tables, `acceptRow(java.lang.Object[])` may throw an `OutOfMemoryError`.
  Since:
    3 Aug 2004

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ListRowStore()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `acceptMetadata(StarTable meta)` Takes delivery of a row-less `StarTable` object which defines the metadata of the table to be transmitted.
    `void` | `acceptRow(java.lang.Object[] row)` Accepts a row.
    `void` | `endRows()` Signals that there are no more rows to be transmitted.
    `StarTable` | `getStarTable()` Obtains a StarTable which contains the data and metadata that have been written into this sink.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ListRowStore

          public ListRowStore()

  - ### Method Detail

    - #### acceptMetadata

          public void acceptMetadata(StarTable meta)

      Description copied from interface: `TableSink`
      Takes delivery of a row-less `StarTable` object which defines the metadata of the table to be transmitted. If the number of rows that will be transmitted via subsequent calls to `acceptRow` is known, this value should be made available as the row count of `meta` (`StarTable.getRowCount()`); if it is not known, the row count should be -1. However, this object should not attempt to read any of `meta`'s cell data.

      The data to be transmitted in subsequent calls of `acceptRow` must match the metadata transmitted in this call in the same way that rows of a StarTable must match its own metadata (number and content clases of columns etc). If this sink cannot dispose of a table corresponding to `meta` then it may throw a TableFormatException - this may be the case if for instance `meta` has columns with types that this sink can't deal with.

      Specified by:
        `acceptMetadata` in interface `TableSink`
      Parameters:
        `meta` - table metadata object

    - #### acceptRow

          public void acceptRow(java.lang.Object[] row)
                         throws java.io.IOException

      Accepts a row.
      Specified by:
        `acceptRow` in interface `TableSink`
      Parameters:
        `row` - table data row
      Throws:
        `java.lang.OutOfMemoryError` - if it's run out of memory
        `java.io.IOException`

    - #### endRows

          public void endRows()

      Description copied from interface: `TableSink`
      Signals that there are no more rows to be transmitted.
      Specified by:
        `endRows` in interface `TableSink`

    - #### getStarTable

          public StarTable getStarTable()

      Description copied from interface: `RowStore`
      Obtains a StarTable which contains the data and metadata that have been written into this sink. In general it is only legal to call this method following a call to `TableSink.endRows()`; failing to observe this sequence may earn you an `IllegalStateException`
      Specified by:
        `getStarTable` in interface `RowStore`
      Returns:
        a random-access StarTable containing the written rows